#include "widget/widget.h"

extern Display* dpy;

class QueryWindow : public NSButtonListener, public NSFrame {
public:
  QueryWindow(const char*, const char*, const char*);
  
  bool left() const { return _left; }
  bool right() const { return _right; }

  void buttonAction(const XEvent&, void*);

  void waitForEvent();
private:
  NSLabel label;
  NSButton leftButton;
  NSButton rightButton;

  NSHContainer con;
  NSVContainer mainCon;

  bool _left;
  bool _right;
};

class SingleOrMultiple : public QueryWindow {
public:
  SingleOrMultiple() : QueryWindow("How many do you want to move?", "Single", "Multiple") {}
  
  bool single() const { return left(); }
  bool multiple() const { return right(); }
};

class AnotherOrQuit : public QueryWindow {
public:
  AnotherOrQuit() : QueryWindow("Another game?", "Yes", "No") {}

  bool another() const { return left(); }
  bool quit() const { return right(); }
};
  
class ScoreWindow : public NSFrame, public NSButtonListener {
public:
  ScoreWindow();
  ~ScoreWindow() { writeScore(); }
  
  void incWins();
  void incDefeats();
  void incUndos();

  void waitForEvent();

  void buttonAction(const XEvent&, void*);
    
private:
  void readScore();
  void writeScore() const;
  void setLabels();

  int _wins, _defeats;
  int _continuousWins;
  bool _previousWon;
  int _undos;
  int _totalScore;

  string saveFile;

  bool exitPressed;

  NSButton exitButton;
  NSLabel winLabel, defeatLabel, winpLabel, defeatpLabel, cwinLabel;
  NSLabel undoLabel, totalLabel;
  NSVContainer mainCon;
};    
