#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

int main()
{
  Display* dpy = XOpenDisplay(NULL);
  Window root = RootWindow(dpy, 0);
  unsigned long white = WhitePixel(dpy, 0), black = BlackPixel(dpy, 0);
  Window parent = XCreateSimpleWindow(dpy, root, 0, 0, 300, 300, 0, 0, white);
  Window child = XCreateSimpleWindow(dpy, parent, 100, 100, 100, 100, 2, black, white);

  XSelectInput(dpy, child, ExposureMask);

  XSetWindowBorderWidth(dpy, child, 10);
  XSetWindowBorder(dpy, child, 1000);

  XMapWindow(dpy, parent);
  XMapWindow(dpy, child);
  XFlush(dpy);

  GC gc = XCreateGC(dpy, child, 0, 0);
  XSetForeground(dpy, gc, black);
  XSetLineAttributes(dpy, gc, 1, LineSolid, CapButt, JoinMiter);

  while (true) {
    XEvent ev;
    XNextEvent(dpy, &ev);
    switch (ev.type) {
    case Expose:
      XDrawString(dpy, child, gc, 20, 20, "abc\0defg", sizeof("abc\0defg"));

      XPoint points[] = { {0, 0}, {100, 0}, {100, 100}, {0, 100}, {0, 0}, {50, 50} };
      XDrawLines(dpy, parent, gc, points, 6, CoordModeOrigin);

      break;
    }
  }

  return 0;
}
